--
-- claasLexion480
-- Specialization for claasLexion480
--
-- @author:		RivalBomb
-- @date:		20/12/15
-- @version:	v1.0
-- @history:	v1.0 - initial version
--
-- free for non-commercial usage

claasLexion480 = {};

function claasLexion480.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Overloading, specializations);
end;

function claasLexion480:load(xmlFile)
	if #InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1 == 1 then
		InputBinding.actions[InputBinding.CL_EMPTY_GRAIN].keys1[1] = InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1[1];
	end;
	self.chopperPartsAnimation = Utils.getNoNil(getXMLString(xmlFile, "vehicle.chopperPartsAnimation#name"),"chopperPartsAnimation");
end;

function claasLexion480:mouseEvent(posX, posY, isDown, isUp, button)
end;

function claasLexion480:keyEvent(unicode, sym, modifier, isDown)
end;

function claasLexion480:update(dt)
    if self:getIsActive() then
        if self.isClient and self:getIsActiveForInput(false) then
            if InputBinding.hasEvent(InputBinding.CL_EMPTY_GRAIN) then
                if self.hasPipe then
                    local nextState = self.targetPipeState+1;
                    if nextState > self.numPipeStates then
                        nextState = 1;
                    end;
                    if self:getIsPipeStateChangeAllowed(nextState) then
                        self:setPipeState(nextState);
                    elseif nextState ~= 1 and self:getIsPipeStateChangeAllowed(1) then
                        -- also try to close the pipe if other states are not allowed
                        self:setPipeState(1);
                    end
                else
                    self:setOverloadingActive(not self.isOverloadingActive);
                end;
            end;
        end;
	end;
end;

function claasLexion480:updateTick(dt)
	if self.isClient then
		if self:getIsTurnedOn() then
			if not self:getIsAnimationPlaying(self.chopperPartsAnimation) then
				self:playAnimation(self.chopperPartsAnimation);
			end;
		else
			if self:getIsAnimationPlaying(self.chopperPartsAnimation) then
				self:stopAnimation(self.chopperPartsAnimation);
			end;
		end;
		local cutterWidth = 4.5;
		for cutter,implement in pairs(self.attachedCutters) do
			cutterWidth = cutter.sizeWidth;
		end;
		self.animations[self.chopperPartsAnimation].parts[1].endRot = {0, math.rad(cutterWidth*(13/3)), 0};
		self.animations[self.chopperPartsAnimation].parts[1].startTime = 0;
		self.animations[self.chopperPartsAnimation].parts[1].duration = (cutterWidth*(13/3))*13;
		self.animations[self.chopperPartsAnimation].parts[2].startRot = {0, math.rad(-cutterWidth*(13/3)), 0};
		self.animations[self.chopperPartsAnimation].parts[2].startTime = 0;
		self.animations[self.chopperPartsAnimation].parts[2].duration = (cutterWidth*(13/3))*13;
		self.animations[self.chopperPartsAnimation].parts[3].startRot = {0, math.rad(cutterWidth*(13/3)), 0};
		self.animations[self.chopperPartsAnimation].parts[3].startTime = (cutterWidth*(13/3))*13;
		self.animations[self.chopperPartsAnimation].parts[3].duration = (cutterWidth*(13/3))*13;
		self.animations[self.chopperPartsAnimation].parts[4].endRot = {0, math.rad(-cutterWidth*(13/3)), 0};
		self.animations[self.chopperPartsAnimation].parts[4].startTime = (cutterWidth*(13/3))*13;
		self.animations[self.chopperPartsAnimation].parts[4].duration = (cutterWidth*(13/3))*13;
	end;
end;
function claasLexion480:onEnter()
	if self.isClient then
		if #InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1 == 1 and InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1[1] == InputBinding.actions[InputBinding.CL_EMPTY_GRAIN].keys1[1] then
			table.insert(InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1, 1, Input.KEY_lshift);
			InputBinding.preprocessInputActions();
		end;
	end;
end;
function claasLexion480:onLeave()
	if self.isClient then
		if #InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1 == 2 and InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1[1] == Input.KEY_lshift then
			table.remove(InputBinding.actions[InputBinding.EMPTY_GRAIN].keys1, 1, Input.KEY_lshift);
			InputBinding.preprocessInputActions();
		end;
	end;
end;

function claasLexion480:draw()
end;

function claasLexion480:delete()
end;